package com.njyunzhi.ubpa.controller;

import com.njyunzhi.ubpa.common.BaseController;
import com.njyunzhi.ubpa.common.DateUtils;
import com.njyunzhi.ubpa.common.ResponseBean;
import com.njyunzhi.ubpa.service.ITaOrgService;
import com.njyunzhi.ubpa.service.ITaResumeWorkFormService;
import com.njyunzhi.ubpa.vo.StatisValue;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Api(tags = "统计")
@RestController
@RequestMapping("/")
public class StatisController extends BaseController {

    @Autowired
    ITaOrgService iTaOrgService;

    @Autowired
    ITaResumeWorkFormService iTaResumeWorkFormService;


    @RequestMapping(value="/admin/statis/comm",method= RequestMethod.GET)
    @ApiOperation(value="工作台统计", notes = "工作台统计", httpMethod = "GET", response = ResponseBean.class)
    public ResponseBean comm() throws Exception {

        // 企业总数
        int orgTotal = iTaOrgService.countTotal();
        // 有数据企业
        int existsDataNum = iTaOrgService.countExistsData();
        // 今日汇总
        LocalDateTime now = LocalDateTime.now();
        String today = DateUtils.toString(now, "yyyy-MM-dd");
        LocalDateTime todayStart = DateUtils.getDayStart(today);
        LocalDateTime todayEnd = DateUtils.getDayEnd(today);
        Map<String, Integer> todayRes = iTaResumeWorkFormService.statisNum(todayStart, todayEnd);
        // 昨日汇总
        String yestoday = DateUtils.toString(LocalDateTime.now().minusDays(1), "yyyy-MM-dd");
        LocalDateTime yestodayStart = DateUtils.getDayStart(yestoday);
        LocalDateTime yestodayEnd = DateUtils.getDayEnd(yestoday);
        Map<String, Integer> yestodayRes = iTaResumeWorkFormService.statisNum(yestodayStart, yestodayEnd);

        Map<String, Integer> res = new HashMap<>();
        res.put("orgTotalNum", orgTotal);
        res.put("noDataOrgNum", orgTotal - existsDataNum);
        res.put("todayReportNum", todayRes.get("total"));
        res.put("todayNormalNum", todayRes.get("normal"));
        res.put("yestodayReportNum", yestodayRes.get("total"));

        return ResponseBean.success(res);
    }
}
